import 'dart:async';

import 'package:flutter/services.dart';
import 'package:shared_preferences/shared_preferences.dart';

class AwcSharedPref {
  static const MethodChannel _channel = MethodChannel('awc_shared_pref');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  final Future<SharedPreferences> _prefs = SharedPreferences.getInstance();

  Future<String> getString(String key, String def) async {
    final SharedPreferences prefs = await _prefs;
    return prefs.getString(key) ?? def;
  }

  Future<bool> setString(String key, String val) async {
    final SharedPreferences prefs = await _prefs;
    bool result = await prefs.setString(key, val);
    return result;
  }

  Future<int> getInt(String key, int def) async {
    final SharedPreferences prefs = await _prefs;
    return prefs.getInt(key) ?? def;
  }

  Future<bool> setInt(String key, int val) async {
    final SharedPreferences prefs = await _prefs;
    bool result = await prefs.setInt(key, val);
    return result;
  }

  Future<double> getDouble(String key, double def) async {
    final SharedPreferences prefs = await _prefs;
    return prefs.getDouble(key) ?? def;
  }

  Future<bool> setDouble(String key, double val) async {
    final SharedPreferences prefs = await _prefs;
    bool result = await prefs.setDouble(key, val);
    return result;
  }

  Future<bool> getBool(String key, bool def) async {
    final SharedPreferences prefs = await _prefs;
    return prefs.getBool(key) ?? def;
  }

  Future<bool> setBool(String key, bool val) async {
    final SharedPreferences prefs = await _prefs;
    bool result = await prefs.setBool(key, val);
    return result;
  }

  Future<bool> setEmpty() async {
    final SharedPreferences prefs = await _prefs;
    return prefs.clear();
  }
}
